package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;



public class FilterDouka2 extends Filter 
{
    /** ֥饷礭 */
        
    /* rewrite */
    int[][] mask1 = {{-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,24,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1}};
    
    int[][] mask2 = {{ 0, 0,-1, 0, 0},
		     { 0,-1,-2,-1, 0},
		     {-1,-2,16,-2,-1},
		     { 0,-1,-2,-1, 0},
		     { 0, 0,-1, 0, 0}};
    int[][] mask3 = { {-1, -1, -1},
		      {-1,  8, -1},
		      {-1, -1, -1}};
    
    int[][] mask4 = {{ 0,-1, 0},
		     {-1, 4,-1},
		     { 0,-1, 0}};
    
    int[][] mask = mask3;
    
    private double R =0.0,
	RMax = 1000.0,
	RMin = 0;
    private double G =0.0,
	GMax = 1000.0,
	GMin = 0;
    private double B =0.0,
	BMax = 1000.0,
	BMin = 0;

    private int offset =mask.length/2;
    /** Υե륿̾Τ֤ */
    public String getName()
    {
	return /* rewrite */ "Douka2";	//"Douka2(3x3)";
    }
	
    /** Υե륿󥰤Ԥ */
    public void filter(AnimatedImage AI)
    {
	int width = AI.getWidth();
	int height = AI.getHeight();
	Random rand = new Random(System.currentTimeMillis());
	
	//饹ѴƤ
	for (int y = 0; y < height; y++) {
	    for(int x = 0; x < width; x++){
		/* rewrite */
		int l = 0;
		int R = 0;		
		int G = 0;
		int B = 0;
		
		
		final int offset = mask.length/2;
		for(int i = 0; i < mask.length; i++){
		    if( y+i-offset < 0 || y+i-offset >= height) break;
		    for(int j = 0; j < mask[i].length; j++){
			if( x+j-offset < 0 || x+j-offset >= width) break;
			
			int r = AI.getR(x + j - offset, y + i - offset);
			int g = AI.getG(x + j - offset, y + i - offset);
			int b = AI.getB(x + j - offset, y + i - offset);
			l += getLuminance(r, g, b) * mask[i][j];
		    }
		}
		l += 128;	/* rewrite */
		if(l < 0) l = 0;
		if(l >= 255) l = 255;
		R = l*170/255;
		G = l*135/255;
		B = l*90/255;
		
		
		AI.setRGB(x, y, R, G ,B );
	    }
	    this.switchThread();	//ѹʬ̤ȿǤ
	}
	this.switchThread();	//ѹʬ̤ȿǤ
	AI.repaintAll();
	return;
    }
    
    /** (r, g, b)鵱٤򻻽Ф */
    public int getLuminance(int r, int g, int b)
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }

    class FilterDouka2Panel extends FilterPanel {

	Label L1 = new Label("Douka"),
	    L2 = new Label("RANGE W<- ->S");
	

	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("1",g, false),
	    cb2 = new Checkbox("2", g,false),
	    cb3 = new Checkbox("3", g , true),
	    cb4 = new Checkbox("4", g, false);

	FilterDouka2Panel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.cb1);
	    this.add(this.cb2);
	    this.add(this.cb3);
	    this.add(this.cb4);
	}
	
	// ե륿Υѥ᡼ꤹ
	public void setFilterParameter(){
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		mask = mask1;
	    }else if(tmp == cb2){
		mask = mask2;
	    }
	    else if (tmp == cb3){
		mask = mask3;
	    }
	    else if (tmp == cb4){
		mask = mask4;
	    }
	}
    }
    
    // ե륿ѥ᡼ꤹ뤿Υѥ֤ͥ
    public FilterPanel getFilterPanel(){
	return new  FilterDouka2Panel();
    }
}
