package imageFiltering;

import java.io.*;
import java.applet.Applet;

/**
 * w肳ꂽfBNǵAẘgq̃t@C̃Xg쐬NX
 */
public class FileListing
{
	/** gp摜t@C̊gq */
	private static final String imageSuffixList[] = {".jpg", ".JPG", ".jpe", ".JPE", ".gif", ".GIF" };
	/** NXt@C̊gq */
	private static final String classSuffixList[] = {".class"};
	
	
	
	/**
	 * C֐
	 *   Xgt@C̃fBNgɍ쐬(t@C͏㏑)
	 */	
	public static void main( String args[] ) 
	{
		FileWriter FW;
		//摜Xg̍쐬
		String imageList[] = FileListing.getFileNameList( MainApplet.imageDirectory, imageSuffixList );
		File imageListFile = new File( MainApplet.imageDirectory + MainApplet.listFileName );
		try {
			FW = new FileWriter( imageListFile );
			for (int i=0; i<imageList.length; i++) {
				FW.write( imageList[i] + "\n" );
				FW.flush();
			}
			FW.close();
		} catch (IOException e) {}
		//tB^Xg̍쐬
		String filterList[] = FileListing.getFileNameList( MainApplet.filterDirectory, classSuffixList );
		File filterListFile = new File( MainApplet.filterDirectory + MainApplet.listFileName );
		try {
			FW = new FileWriter( filterListFile );
			for (int i=0; i<filterList.length; i++) {
				FW.write( filterList[i] + "\n" );
				FW.flush();
			}
			FW.close();
		} catch (IOException e) {}
		
		return;
	}
	
	
	
	//w肳ꂽgq̃XgnāA̎ނ̃t@CXgɂĕԂ
	public static String[] getFileNameList( String directoryName, final String filterList[] )
	{
		File file = new File( directoryName );
		if ( file == null ) return null;
		
		return file.list( new FilenameFilter()	//NX
							{ 
								public boolean accept( File dir, String name ) 
								{
									if ( filterList == null ) {
										return true;
									} else {
										for (int i=0; i<filterList.length; i++) {
											if ( name.endsWith( filterList[i] ) ) return true;
										}
									}
									return false;
								}
							} 
						  );
	}
}
