package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;



public class FilterDouka extends Filter 
{
    /** ֥饷礭 */
        
    /* rewrite */
    int[][] mask1 = {{-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,24,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1}};
    
    int[][] mask2 = {{ 0, 0,-1, 0, 0},
		     { 0,-1,-2,-1, 0},
		     {-1,-2,16,-2,-1},
		     { 0,-1,-2,-1, 0},
		     { 0, 0,-1, 0, 0}};
    int[][] mask3 = { {-1, -1, -1},
		      {-1,  8, -1},
		      {-1, -1, -1}};
    
    int[][] mask4 = {{ 0,-1, 0},
		     {-1, 4,-1},
		     { 0,-1, 0}};
    
    int[][] mask = mask1;
    
    /*ѥ᡼Ǥңǣͤ롣*/

    private int XR =255,
	RMax = 255,
	RMin = 0;
    private int XG =255,
	GMax = 255,
	GMin = 0;
    private int XB =255,
	BMax = 255,
	BMin = 0;

    private int offset =mask.length/2;
    /** Υե륿̾Τ֤ */
    public String getName()
    {
	return /* rewrite */ "Douka";
    }
	
    /** Υե륿󥰤Ԥ */
    public void filter(AnimatedImage AI)
    {
	int width = AI.getWidth();
	int height = AI.getHeight();
	Random rand = new Random(System.currentTimeMillis());
	
	//饹ѴƤ
	for (int y = 0; y < height; y++) {
	    for(int x = 0; x < width; x++){
		/* rewrite */
		int l = 0;
		
		/*äΣңǣ¤Ͽľܴؤ*/
		int R = 0;		
		int G = 0;
		int B = 0;
		
		
		final int offset = mask.length/2;
		for(int i = 0; i < mask.length; i++){
		    if( y+i-offset < 0 || y+i-offset >= height) break;
		    for(int j = 0; j < mask[i].length; j++){
			if( x+j-offset < 0 || x+j-offset >= width) break;
			
			int r = AI.getR(x + j - offset, y + i - offset);
			int g = AI.getG(x + j - offset, y + i - offset);
			int b = AI.getB(x + j - offset, y + i - offset);
			l += getLuminance(r, g, b) * mask[i][j];
		    }
		}
		l += 128;	/* rewrite */
		if(l < 0)l = 0;
		    
		if(l >= 255)l = 255;
		/*ǻФȣءȤ̤ȿǤ*/
		R = l*XR/255;
		G = l*XG/255;
		B = l*XB/255;
		
		AI.setRGB(x, y, R, G ,B );
	    }
	    this.switchThread();	//ѹʬ̤ȿǤ
	}
	this.switchThread();	//ѹʬ̤ȿǤ
	AI.repaintAll();
	return;
    }
    
    /** (r, g, b)鵱٤򻻽Ф */
    public int getLuminance(int r, int g, int b)
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }

    class FilterDoukaPanel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Douka"),
	    L2 = new Label("RANGE W<- ->S"),
	    L3 = new Label("R"),
	    L4 = new Label("G"),
	    L5 = new Label("B");
	
	TextField T1 = new TextField(""+XR,255),
	    T2 = new TextField(""+XG,255),
	    T3 = new TextField(""+XB,255);

	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("1",g, true),
	    cb2 = new Checkbox("2", g,false),
	    cb3 = new Checkbox("3", g ,false ),
	    cb4 = new Checkbox("4", g, false);

	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,256),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,256),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,256);

	FilterDoukaPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.cb1);
	    this.add(this.cb2);
	    this.add(this.cb3);
	    this.add(this.cb4);
	    this.add(this.L3);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L4);
	    this.add(this.S2);
	    this.add(this.T2);
	    this.add(this.L5);
	    this.add(this.S3);
	    this.add(this.T3);
	    
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    

	    
	}
	
	// ե륿Υѥ᡼ꤹ
	public void setFilterParameter()
	{
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		mask = mask1;
	    }else if(tmp == cb2){
		mask = mask2;
	    }
	    else if (tmp == cb3){
		mask = mask3;
	    }
	    else if (tmp == cb4){
		mask = mask4;
	    }
	    
	    try{
		XR = Integer.parseInt(T1.getText());
		}
	    catch(NumberFormatException e){}
	    if(XR > RMax) XR = RMax;
	    if(XR < RMin) XR = RMin;
	    T1.setText(""+XR);
	    try{
		XG = Integer.parseInt(T2.getText());
		}
	    catch(NumberFormatException e){}
	    if(XG > GMax) XG = GMax;
	    if(XG < GMin) XG = GMin;
	    T1.setText(""+XG);
	    try{
		XB = Integer.parseInt(T3.getText());
		}
	    catch(NumberFormatException e){}
	    if(XB > BMax) XB = BMax;
	    if(XB < BMin) XB = BMin;
	    T1.setText(""+XB);

	}
	
	/*ǥСȥƥȥեɤϢŤ롣*/
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+val);
	    }
	    
	}
    }
    // ե륿ѥ᡼ꤹ뤿Υѥ֤ͥ
    public FilterPanel getFilterPanel(){
	return new  FilterDoukaPanel();
    }
}
