/*---------------------------------------------------------
  摜Applet nCpXtB^
  Copyright (C) 2000, Hatsuyama Kazuhide
  ver1.00 (2000/12/4)

  modified by Hashimoto Ryota (2001/11/22)
  ImageFilteringAvbgœ悤ɏC
  --------------------------------------------------------*/


package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;


/**
 * ̊GGAuVŏ悤ȊG𐶐tB^B
 * /* rewrite *//* nCpXtB^
 */
public class FilterHighPass extends Filter 
{
    /** uV̑傫 */
        
    /* rewrite */
    int[][] mask1 = {{-1,-1,-1,-1,-1},
		    {-1,-1,-1,-1,-1},
		    {-1,-1,24,-1,-1},
		    {-1,-1,-1,-1,-1},
		    {-1,-1,-1,-1,-1}};

    int[][] mask2 = {{ 0, 0,-1, 0, 0},
	{ 0,-1,-2,-1, 0},
	{-1,-2,16,-2,-1},
	{ 0,-1,-2,-1, 0},
	{ 0, 0,-1, 0, 0}};
    int[][] mask3 = { {-1, -1, -1},
		      {-1,  8, -1},
		      {-1, -1, -1}};

    int[][] mask4 = {{ 0,-1, 0},
	{-1, 4,-1},
	{ 0,-1, 0}};

    int[][] mask = mask3;

    /** ̃tB^̖̂Ԃ */
    public String getName()
    {
	return /* rewrite */ "HighPass";	//"HighPass(3x3)";
    }
	
    /** 摜̃tB^Os */
    public void filter(AnimatedImage AI)
    {
	int width = AI.getWidth();
	int height = AI.getHeight();
	Random rand = new Random(System.currentTimeMillis());

	//X^XLɕϊĂ
	for (int y = 0; y < height; y++) {
	    for(int x = 0; x < width; x++){
				/* rewrite */
		int l = 0;
		final int offset = mask.length/2;
		for(int i = 0; i < mask.length; i++){
		    if( y+i-offset < 0 || y+i-offset >= height) break;
		    for(int j = 0; j < mask[i].length; j++){
			if( x+j-offset < 0 || x+j-offset >= width) break;

			int r = AI.getR(x + j - offset, y + i - offset);
			int g = AI.getG(x + j - offset, y + i - offset);
			int b = AI.getB(x + j - offset, y + i - offset);
			l += getLuminance(r, g, b) * mask[i][j];
		    }
		}/*
				//(x, y)N_ɋPx̏d݂aƂ
				//Ȃ񂩔ɊԈĂC邪A
				//IWiƓ悤ɋLqĂ
				int l = 0;
				for(int i = 0; i < mask.length; i++){
				if(y + i >= height) break;
				for(int j = 0; j < mask[i].length; j++){
				if(x + j >= width) break;

				int r = AI.getR(x + j, y + i);
				int g = AI.getG(x + j, y + i);
				int b = AI.getB(x + j, y + i);
				l += getLuminance(r, g, b) * mask[i][j];
				}
				}*/
		l += 128;	/* rewrite */
		if(l < 0) l = 0;
		if(l >= 255) l = 255;
		AI.setRGB(x, y, l, l, l);
	    }
	    this.switchThread();	//ύXʂɔf
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;
    }

    /** (r, g, b)PxZo */
    public int getLuminance(int r, int g, int b)
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }

    class FilterHighPassPanel extends FilterPanel {

	Label L1 = new Label("HighPass"),
	    L2 = new Label("RANGE W<- ->S");
	

	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("1",g, false),
	    cb2 = new Checkbox("2", g,false),
	    cb3 = new Checkbox("3", g , true),
	    cb4 = new Checkbox("4", g, false);

	FilterHighPassPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.cb1);
	    this.add(this.cb2);
	    this.add(this.cb3);
	    this.add(this.cb4);
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		mask = mask1;
	    }else if(tmp == cb2){
		mask = mask2;
	    }
	    else if (tmp == cb3){
		mask = mask3;
	    }
	    else if (tmp == cb4){
		mask = mask4;
	    }
	}
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterHighPassPanel();
    }
}
