package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class FilterMultiplexscale4  extends Filter
{
    private int windowSize = 5,	//ɥ(Ǥ뤳)
	windowSizeMax = 35,
	windowSizeMin = 1;
    
    private double SIGMA =Math.pow(2.0,-3),	//ܤ˱ƶ
	SIGMAMax = 1000.0,
	SIGMAMin = 0.0001;
    
    private int I=16;
    private double SIGMA2[]=new double[I];	
    
    
    //嵭ĤѹС¾˽ɬפϤʤ
    
    
    
    private int offset = (windowSize-1) / 2;
    
    private double ND[][][] = new double[I][offset*2+1][offset*2+1];
    
    
	
	
	
	
    //Ťߤη׻
    void weight(int n){
	int size = offset*2+1;
	double t[] = new double[size];

	    SIGMA2[n] = Math.sqrt(Math.pow(2.0,n-3));
	    final double k = 1.0 / Math.sqrt(2.0 * Math.PI) / SIGMA2[n];
	    //final  ĤѿˤͤǤޤ 
	    double total = 0.0;
	    for (int i=0; i<size; i++) {
		double x = i - offset;
		t[i] = k / Math.exp( x * x / (2 * SIGMA2[n] * SIGMA2[n]) );
		total += t[i];
	    }
	    for (int i=0; i<size; i++) t[i] /= total;
	    for (int i=0; i<size; i++) {
		for (int j=0; j<size; j++) {
		    ND[n][i][j] = t[i] * t[j];
		}
		
	    }
    }
    
    //Υե륿̾Τ֤
    public String getName()
    {
	int size = offset*2+1;
	return "Multiplexscale4";
    }
	
    //Υե륿
    public void filter(AnimatedImage AI)
    {

	for(int n=0;n<I;n++)
	weight(n);	
	double a1=Math.sqrt(Math.pow(2.0,11));
	double a2=Math.sqrt(Math.sqrt(Math.sqrt(Math.sqrt(2))));
	double total;
	double sumR[]=new double [I];
	double sumG[]=new double [I];
	double sumB[]=new double [I];
	 double w1[]=new double[I];
	 double w2[] = new double[I];
	 double DR[]=new double[I];
	 double DG[]=new double[I];
	 double DB[]=new double[I];
	 double SIGMA2[]=new double[I];
	 double FR1=0.0,FG1=0.0,FB1=0.0;
	
	 double FR2=0.0,FG2=0.0,FB2=0.0;
	 double b2 =0.5; 
	 double b=1.0;
	 int L1,L2;
	 double L3;
	 int  FR3=200,FG3=200,FB3=200;
	 double FR4,FG4,FB4;
	 
	 for (int y=0; y<AI.getHeight(); y++) {
	     for (int x=0; x<AI.getWidth(); x++) {
		 for(int n=0;n<I;n++){
		     total = sumR[n] = sumG[n] = sumB[n] = 0.0;
		 }
		 for(int n=0;n<I;n++){
		     DR[n]=DG[n]=DB[n]=0.0;
		 }
		 for(int n=0;n<I;n++){
		     total=0;
		     if ( x-offset<0 || x+offset>=AI.getWidth() 
			  || y-offset<0 || y+offset>=AI.getHeight() ) {	//̤üʬ
			 
			 for (int ix=-offset; ix<=offset; ix++) {
			     for (int iy=-offset; iy<=offset; iy++) {
				 if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
				 total += ND[n][ix+offset][iy+offset];
				 sumR[n] += AI.getR( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
				 sumG[n] += AI.getG( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
				 sumB[n] += AI.getB( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			     }
			 }
			 sumR[n] /= total;  sumG[n] /= total;  sumB[n] /= total;  
		     }else {		//̤ʬ
			 for (int ix=-offset; ix<=offset; ix++) {
			     for (int iy=-offset; iy<=offset; iy++) {
				 sumR[n] += AI.getR( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
				 sumG[n] += AI.getG( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
				 sumB[n] += AI.getB( x+ix, y+iy ) * ND[n][ix+offset][iy+offset];
			     }
			 }
		     }
		 }
		 
		 
		 
		 //κ
		 for(int n=0;n<I;n++){
		     if(n<=2)
			 w1[n]=0;
		     else
			 w1[n]=a1/Math.sqrt(Math.pow(2,(n+1)-3));
		 }
		 for(int n=0;n<I-1;n++){
		     DR[n]=sumR[n+1]-sumR[n];  
		     DG[n]=sumG[n+1]-sumG[n];   
		     DB[n]=sumB[n+1]-sumB[n];
		     
		 }
		 for(int n=0;n<I-1;n++){
		     FR1=FR1+DR[n]*w1[n];
		     FG1=FG1+DG[n]*w1[n];
		     FB1=FB1+DB[n]*w1[n];
		 }
		 
		 FR1=FR1+b+sumR[14];
		 FG1=FG1+b+sumG[14];
		 FB1=FB1+b+sumB[14];
		 FR1=gethanni(FR1);
		 FG1=gethanni(FG1);
		 FB1=gethanni(FB1);
		 L1 =getLuminance((int)FR1,(int)FG1,(int)FB1);//٤
		 for(int n=0;n<I;n++)
		     {
			 if(n>=13)
			     w2[n]=0;
			 else 
			     w2[n]=a2*Math.sqrt(Math.pow(2,(n+1)-3));
		     }
		 for(int n=0;n<I;n++){
		     FR2=FR2+DR[n]*w2[n];
		     FG2=FG2+DG[n]*w2[n];
		     FB2=FB2+DB[n]*w2[n];
		 }
		 FR2=FR2+b2+sumR[14];
		 FG2=FG2+b2+sumG[14];
		 FB2=FB2+b2+sumB[14];
		 FR2=gethanni(FR2);
		 FG2=gethanni(FG2);
		 FB2=gethanni(FB2);
		 L2=getLuminance((int)FR2,(int)FG2,(int)FB2); //٤
		  L3=L1*L2/255;
		 FR4=L3*FR3/255;FG4=L3*FG3/255;FB4=L3*FB3/255;
		AI.setRGB(x,y,(int)Math.rint(FR4),(int)Math.rint(FG4),(int)Math.rint(FB4));
	     }
	     this.switchThread();
	 }
	 
	 this.switchThread();	//ѹʬ̤ȿǤ
	 AI.repaintAll();
	 return;
	 
    }
    public double gethanni(double a)
    {
	if(a<0) a=0;
	if(a>255)a=255;
	return a;
    }
    
    public int getLuminance(int r, int g, int b) //٤
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }
    
    
    
    /* ѹ */
    /* ̾Υե륿˲äưʲĤäƤ */
    
   
 class FilterGaussianPanel extends FilterPanel implements AdjustmentListener{
	
	Label L1 = new Label("Gaussian parameter"),
	    //      L2 = new Label("sigma "),
	    L3 = new Label("Window Size");
	TextField //T1 = new TextField(""+SIGMA,5),
	    T2 = new TextField(""+windowSize,5);
	Scrollbar //S1 = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,1000),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,3,0,20);
	
	FilterGaussianPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    //    this.add(this.L2);
	    // this.add(this.S1);
	    //    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    //    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	}
	
	// ե륿Υѥ᡼ꤹ
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMax) windowSize = windowSizeMax;
	    if(windowSize < windowSizeMin) windowSize = windowSizeMin;
	    T2.setText(""+windowSize);
	    try{
		//	SIGMA = Double.parseDouble(T1.getText());
	    }catch(NumberFormatException e){}
	    if(SIGMA > SIGMAMax) SIGMA = SIGMAMax;
	    if(SIGMA < SIGMAMin) SIGMA = SIGMAMin;
	    //    T1.setText(""+SIGMA);
	    offset = (windowSize-1) / 2;
	    ND = new double[I][offset*2+1][offset*2+1];
	}
	
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    /*  if(se == S1){
		val = S1.getValue();
		//	T1.setText(""+val/10.0);
		}*/
	    if(se == S2){
		val = S2.getValue();
		T2.setText(""+(val*2+1));
	    }
	}  
    }
    
    // ե륿ѥ᡼ꤹ뤿Υѥ֤ͥ
    public FilterPanel getFilterPanel(){
	return new  FilterGaussianPanel();
    }
}
