package imageFiltering.filter;

import java.awt.*;
import java.util.Random;
import imageFiltering.*;
import java.applet.*;
import java.awt.event.*;


/** 
  * RGBؤե륿
  */

public class FilterRGB2 extends Filter
{
	int RGB = 1;


    /* re-report */
    
    /******************************************************************/

    /*ѥ᡼ǻѤRGBͤ*/
    private int XR =0,
	RMax = 100,
	RMin = 0;
    private int XG =0,
	GMax = 100,
	GMin = 0;
    private int XB =0,
	BMax = 100,
	BMin = 0;

    /******************************************************************/
    
    /** Υե륿̾Ρ*/
    public String getName()
    {
	return "RGB";
    }
    
    /** Υե륿󥰡*/
    public void filter(AnimatedImage AI)
    {
	int width = AI.getWidth();
	int height = AI.getWidth();
	int k;    //򴹤ͤŪ˳ǼƤѿ
	int i=0,j=0;   //֥饤ɤ򤹤뤿˾Ƚ򤹤뤿ѿ
	for(int y=0; y<height; y++)
	    {
	    for(int x=0; x<width; x++)
		{
		    int R = AI.getR(x,y);
		    int G = AI.getG(x,y);
		    int B = AI.getB(x,y);

		    /* re-report */

        /******************************************************************/

		    //ǡ
		    if(RGB == 1){
			int l = (int)(0.3f*R+0.59f*G+0.11f*B);
			B=B+x+XB; R=R+y+XR; G=G-x-y+XG;
		    }
		    
		    //ǡ
		    if(RGB == 2){
			int l = (int)(0.3f*R+0.59f*G+0.11f*B);
			B=B+y+XB*l/30; R=R+x+XR*l/30; G=G+x-y+XG*l/30;
		    }

        /******************************************************************/
		    
		    AI.setRGB(x,y,R,G,B);
		}

	    this.switchThread();
	    }
	this.switchThread();
	AI.repaintAll();
	return;
    }
 
   

    /* re-report */

    /******************************************************************/


    /** ѥͥ롡*/

   class FilterRGB2Panel extends FilterPanel implements AdjustmentListener{

	Label L1 = new Label("Gradation"),
	    L2 = new Label("RANGE W<- ->S"),
	    L3 = new Label("R"),
	    L4 = new Label("G"),
	    L5 = new Label("B");
	
	TextField 
	    T1 = new TextField(""+XR,100),
	    T2 = new TextField(""+XG,100),
	    T3 = new TextField(""+XB,100);

	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("gradation1",g, true),
	    cb2 = new Checkbox("gradation2", g,false);

       Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,101),
	   S2 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,101),
	   S3 = new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,101);

	FilterRGB2Panel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.cb1);
	    this.add(this.cb2);
	    this.add(this.L3);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L4);
	    this.add(this.S2);
	    this.add(this.T2);
	    this.add(this.L5);
	    this.add(this.S3);
	    this.add(this.T3);
	    
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    

	    
	}
	
	// ե륿Υѥ᡼ꤹ
	public void setFilterParameter()
	{
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		RGB = 1;
	    }
	    else if(tmp == cb2){
		RGB = 2;
	    }

	    
	    try{
		XR = Integer.parseInt(T1.getText());
		}
	    catch(NumberFormatException e){}
	    if(XR > RMax) XR = RMax;
	    if(XR < RMin) XR = RMin;
	    T1.setText(""+XR);
	    try{
		XG = Integer.parseInt(T2.getText());
		}
	    catch(NumberFormatException e){}
	    if(XG > GMax) XG = GMax;
	    if(XG < GMin) XG = GMin;
	    T1.setText(""+XG);
	    try{
		XB = Integer.parseInt(T3.getText());
		}
	    catch(NumberFormatException e){}
	    if(XB > BMax) XB = BMax;
	    if(XB < BMin) XB = BMin;
	    T1.setText(""+XB);

	}
	
	/*ǥСȥƥȥեɤϢŤ롣*/
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val);
	    }
	
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+val);
	    }
	    
	}
    }

    /******************************************************************/

	
    // ե륿ѥ᡼ꤹ뤿Υѥ֤ͥ
	public FilterPanel getFilterPanel(){
	    return new  FilterRGB2Panel();
	}
	
}
    
    

    

