//bvtB^

/* 
   02TI034
    
*/

package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;/*********/

public class FilterTTTT extends Filter
{
    private int wrap =30,
	wrapMax=100,
	wrapMin=1;

    
    private int windowSize = 11,	//EBhETCY(ł邱)
	windowSizeMax = 35,
	windowSizeMin = 1;
    
    private double SIGMA = 10.0,	//ڂɉe
	SIGMAMax = 1000.0,
	SIGMAMin = 0.0001;
    
    //L̓ύX΁AɏC̕Kv͂Ȃ
    
	
    
    private int offset1 = (windowSize-1) / 2;
    private double ND[][] = new double[offset1*2+1][offset1*2+1];
    
    private int offset2,offset3;
      private int gaussian=0;
 /********************************************************************/
    /* rewrite */
  
    int[][] mask1 = {{-1,-2,-1},
		     { 0, 0, 0},
		     { 1, 2, 1}};
    
    int[][] mask2 = {{-1,-1,-1},
		     {-1, 8,-1},
		     {-1,-1,-1}};
    
    int[][] mask3 = {{ 0,-1, 0},
		     {-1, 4,-1},
		     { 0,-1, 0}};
    
    int[][] mask4 = {{-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,24,-1,-1},
		     {-1,-1,-1,-1,-1},
		     {-1,-1,-1,-1,-1}};
   
    int[][] mask5 = {{ 0, 0, 0,-1,-1,-1, 0, 0, 0},
		     { 0, 0,-1,-1,-2,-1,-1, 0, 0},
		     { 0,-1,-1,-1,-3,-1,-1,-1, 0},
		     {-1,-1,-1,-2,-3,-2,-1,-1,-1},
		     {-1,-2,-3,-3,80,-3,-3,-2,-1},
		     {-1,-1,-1,-2,-3,-2,-1,-1,-1},   
		     { 0,-1,-1,-1,-3,-1,-1,-1, 0},
		     { 0, 0,-1,-1,-2,-1,-1, 0, 0},
		     { 0, 0, 0,-1,-1,-1, 0, 0, 0}};
    
    int[][] maskA = mask5;
    
    int[][] maskB = mask5;

    
    
    /*******************************************************************/
    
    //ď݂vZ
    void weight(){
	int size = offset1*2+1;
	double t[] = new double[size];
	final double k = 1.0 / Math.sqrt(2.0 * Math.PI) / SIGMA;
	double total = 0.0;
	for (int i=0; i<size; i++) {
	    double x = i - offset1;
	    t[i] = k / Math.exp( x * x / (2 * SIGMA * SIGMA) );
	    total += t[i];
	}
	for (int i=0; i<size; i++) t[i] /= total;
	for (int i=0; i<size; i++) {
	    for (int j=0; j<size; j++) {
		ND[i][j] = t[i] * t[j];
	    }
	}
    }
    
    
    //̃tB^̖̂Ԃ
    public String getName()
    {
	int size = offset1*2+1;
	return "wrap";
    }
    
    //摜̃tB^O
    public void filter(AnimatedImage AI)
    {
	int R,G,B;
	int width = AI.getWidth();
	int height = AI.getHeight();
	for (int y = 0; y < height; y++) {
	    for(int x = 0; x < width; x++){
		R=AI.getR(x,y);	G=AI.getG(x,y);	B=AI.getB(x,y);
		AI.settmpRGB( x, y, R, G, B );
	    }
	}
	
	filterGaussian(AI);
	filterGaussian(AI);
	filterMask(AI);
	filterGaussian(AI);
	filterReverse(AI);
	//	filterGaussianlast(AI);
	return;    
    }
    
    /************************************************************/
    
    public void filterGaussian(AnimatedImage AI)
    {
	//gaussian += offset1;
	weight();
	
	double total, sumR, sumG, sumB;
	//	for (int y=gaussian; y<AI.getHeight()-gaussian; y++) {
	//   for (int x=gaussian; x<AI.getWidth()-gaussian; x++) {
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		total = sumR = sumG = sumB = 0.0;
		if ( x-offset1<0 || x+offset1>=AI.getWidth() 
		     || y-offset1<0 || y+offset1>=AI.getHeight() ) {	//ʂ̒[̕
		    for (int ix=-offset1; ix<=offset1; ix++) {
			for (int iy=-offset1; iy<=offset1; iy++) {
			    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
			    total += ND[ix+offset1][iy+offset1];
			    sumR += AI.gettmpR( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			    sumG += AI.gettmpG( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			    sumB += AI.gettmpB( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			}
		    }
		    sumR /= total;  sumG /= total;  sumB /= total;  
		} else {		//ʂ̒
		    for (int ix=-offset1; ix<=offset1; ix++) {
			for (int iy=-offset1; iy<=offset1; iy++) {
			    sumR += AI.gettmpR( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			    sumG += AI.gettmpG( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			    sumB += AI.gettmpB( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
			}
		    }
		}
	
	/*ňꎞ摜ɃZbgĂ܂Ǝ̃sNZ
		  }XN܂Ȃ̂łƂňꎞ摜ɃZbg*/
		AI.setRGB( x, y, (int)Math.rint(sumR), (int)Math.rint(sumG), (int)Math.rint(sumB) );
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf

	/*ňꎞ摜ɃZbg*/
	//for (int y = gaussian; y < AI.getHeight()-gaussian; y++) {
	//for(int x = gaussian; x < AI.getWidth()-gaussian; x++){
	for (int y = 0; y < AI.getHeight(); y++) {
	    for(int x = 0; x < AI.getWidth(); x++){
		int R=AI.getlastR(x,y);
		int G=AI.getlastG(x,y);
		int B=AI.getlastB(x,y);
		AI.settmpRGB( x, y, R, G, B );
	    }
	}

	AI.repaintAll();
	return;
    }
    
    /************************************************************/
    public void filterGaussianlast(AnimatedImage AI)
    {

	weight();
	
	double total, sumR, sumG, sumB;
	for (int y=0; y<AI.getHeight(); y++) {
	    for (int x=0; x<AI.getWidth(); x++) {
		if((AI.gettmpR(x,y)!=AI.gettmpG(x,y))
		   &&
		   (AI.gettmpG(x,y)!=AI.gettmpB(x,y)))	
		    {
			total = sumR = sumG = sumB = 0.0;
			if ( x-offset1<0 || x+offset1>=AI.getWidth() 
			     || y-offset1<0 || y+offset1>=AI.getHeight() ) {	//ʂ̒[̕
			    for (int ix=-offset1; ix<=offset1; ix++) {
				for (int iy=-offset1; iy<=offset1; iy++) {
				    if ( x+ix<0 || x+ix>=AI.getWidth() || y+iy<0 || y+iy>=AI.getHeight() ) continue;
				    total += ND[ix+offset1][iy+offset1];
				    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				}
			    }
			    sumR /= total;  sumG /= total;  sumB /= total;  
			} else {		//ʂ̒
			    for (int ix=-offset1; ix<=offset1; ix++) {
				for (int iy=-offset1; iy<=offset1; iy++) {
				    sumR += AI.getR( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				    sumG += AI.getG( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				    sumB += AI.getB( x+ix, y+iy ) * ND[ix+offset1][iy+offset1];
				} 
			    } 
			}
				AI.settmpRGB( x, y, (int)Math.rint(sumR), (int)Math.rint(sumG), (int)Math.rint(sumB) );
			AI.setRGB( x, y, (int)Math.rint(sumR), (int)Math.rint(sumG), (int)Math.rint(sumB) );
		    }
	    }
	    this.switchThread();
	}
	this.switchThread();	//ύXʂɔf
	AI.repaintAll();
	return;
    }
    
    /*GbWo*/
    /****************************************************************/
    public void filterMask(AnimatedImage AI)
    {
	int RGBsum=0,RGBaverage;
	int width = AI.getWidth();
	int height = AI.getHeight();
	Random rand = new Random(System.currentTimeMillis());
	offset2 = maskA.length/2;
	
	gaussian += offset2;
		
	//X^XLɕϊĂ
	for (int y = gaussian; y < height-gaussian; y++) {
	    for(int x = gaussian; x < width-gaussian; x++){
		//for (int y = 0; y < height; y++) {
		//for(int x = 0; x < width; x++){
		/* rewrite */
		int l = 0;
		
		
		for(int i = 0; i < maskA.length; i++){
		    if( y+i-offset2 < 0 || y+i-offset2 >= height) break;
		    for(int j = 0; j < maskA[i].length; j++){
			if( x+j-offset2 < 0 || x+j-offset2 >= width) break;
			
			int r = AI.gettmpR(x + j - offset2, y + i - offset2);
			int g = AI.gettmpG(x + j - offset2, y + i - offset2);
			int b = AI.gettmpB(x + j - offset2, y + i - offset2);
			l += getLuminance(r, g, b) * maskA[i][j];
		    }
		}
		
			l+=128;
		if(l < 0) l = 0;
		if(l >= 255) l = 255;
		
		/*ňꎞ摜ɃZbgĂ܂Ǝ̃sNZ
		  }XN܂Ȃ̂łƂňꎞ摜ɃZbg*/
		AI.setRGB(x, y, l, l, l);
		//	AI.settmpRGB( x, y, l, l, l );
	    }this.switchThread();//ύXʂɔf
	}this.switchThread();//ύXʂɔf
		AI.repaintAll();
	
	/*ňꎞ摜ɃZbg*/
	
	//for (int y = gaussian; y < height-gaussian; y++) {
	//for(int x = gaussian; x < width-gaussian; x++){
	for (int y = 0; y < height; y++) {
	    for(int x = 0; x < width; x++){
		int R=AI.getlastR(x,y);
		int G=AI.getlastG(x,y);
		int B=AI.getlastB(x,y);
		AI.settmpRGB( x, y, R, G, B );
	    }
	}
	
	
	
	return;
    }
    
    public void filterReverse(AnimatedImage AI)
    {
	AI.resetImage();
	
	int RGBsum=0,RGBaverage;
	int width = AI.getWidth();
	int height = AI.getHeight();
	Random rand = new Random(System.currentTimeMillis());
	offset3 = maskB.length/2;

	gaussian += offset3;
	int l = 0;
	//X^XLɕϊĂ	
	//	for (int y = gaussian; y < height-gaussian; y++) {
	//  for(int x = gaussian; x < width-gaussian; x++){
		for (int y = 0; y < height; y++) {
		for(int x = 0; x < width ; x++){
		/* rewrite */
		 l = 0;
		
		/*	
		for(int i = 0; i < maskB.length; i++){
		    if( y+i-offset3 < 0 || y+i-offset3 >= height) break;
		    for(int j = 0; j < maskB[i].length; j++){
			if( x+j-offset3 < 0 || x+j-offset3 >= width) break;
			
			int r = AI.gettmpR(x + j - offset3, y + i - offset3);
			int g = AI.gettmpG(x + j - offset3, y + i - offset3);
			int b = AI.gettmpB(x + j - offset3, y + i - offset3);
			l += getLuminance(r, g, b) * maskB[i][j];
		    }
		}
		*/	int r = AI.gettmpR(x, y);
			int g = AI.gettmpG(x, y);
			int b = AI.gettmpB(x, y);
			l = getLuminance(r, g, b);
		       
	
			l=(255-l)+wrap;
		
		if(l < 0) l = 0;
		if(l >= 255) l = 255;
		
	
		if(l>(255-60)){
		    l=(l-(255-60))*(255/60)+(255%(60));
		    if(l < 0) l = 0;
		    if(l >= 255) l = 255;
		    AI.settmpRGB( x, y, l, l, l );
		    AI.setRGB( x, y, l, l, l );	//\摜sNZ(x,y)ɐF(R,G,B)Zbg	
		}	
		else {
		    int R=AI.getlastR(x,y);
		    int G=AI.getlastG(x,y);
		    int B=AI.getlastB(x,y);
		    AI.settmpRGB( x, y, R, G, B );
		}
		 
		    
	
		    
	    }  this.switchThread();//ύXʂɔf
	} this.switchThread();//ύXʂɔf
	AI.repaintAll();
	

	
		

	
	return;
    }
  
    
    
    
    /********************************************************************/
    
    public int getLuminance(int r, int g, int b)
    {
	return (int)(0.3f*r + 0.59f*g + 0.11f*b);
    }
    
    /********************************************************************/
    
    /* vύX_ */
    /* ʏ̃tB^ɉĈȉ̓Ă */
    
    class FilterTTTTPanel extends FilterPanel implements AdjustmentListener{
	Label L1 = new Label("Gaussian parameter"),
	    L2 = new Label("sigma "),
	    L3 = new Label("Window Size");
	TextField T1 = new TextField(""+SIGMA,5),
	    T2 = new TextField(""+windowSize,5),
	    T3 = new TextField(""+wrap,5);
	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,100,1,0,1000),
	    S2 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,3,0,20),
	    S3 = new Scrollbar(Scrollbar.HORIZONTAL,wrap,1,1,100);
	/******************************************************************/
	Label L4 = new Label("HighPass"),
	    L5 = new Label("RANGE W<- ->S"),
	    L6 = new Label("wrap̌");
	
	CheckboxGroup g = new CheckboxGroup();
	Checkbox
	    cb1 = new Checkbox("1",g, false),
	    cb2 = new Checkbox("2", g,false),
	    cb3 = new Checkbox("3", g ,true),
	    cb4 = new Checkbox("4", g, false),
	    cb5 = new Checkbox("5", g, false);
	/*************************************************************/
	FilterTTTTPanel(){
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    /*********************************************************/
	    this.add(new Container());/****/
	    this.add(this.L4);
	    this.add(this.L5);
	    this.add(this.cb1);
	    this.add(this.cb2);
	    this.add(this.cb3);
	    this.add(this.cb4);  
	    this.add(this.cb5);
	    /*********************************************************/
	   
	    this.add(this.L6);
	    this.add(this.S3);
	    this.add(this.T3);
	    /*********************************************************/
	    
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	    
	}
	
	// tB^̃p[^擾ݒ肷
	public void setFilterParameter(){
	    try{
		windowSize = Integer.parseInt(T2.getText());
	    }catch(NumberFormatException e){}
	    if(windowSize > windowSizeMax) windowSize = windowSizeMax;
	    if(windowSize < windowSizeMin) windowSize = windowSizeMin;
	    T2.setText(""+windowSize);
	    try{
		SIGMA = Double.parseDouble(T1.getText());
	    }catch(NumberFormatException e){}
	    if(SIGMA > SIGMAMax) SIGMA = SIGMAMax;
	    if(SIGMA < SIGMAMin) SIGMA = SIGMAMin;
	    T1.setText(""+SIGMA);
	    
	    try{
		wrap = Integer.parseInt(T3.getText());
	    }catch(NumberFormatException e){}
	    if(wrap > wrapMax) wrap = wrapMax;
	    if(wrap < wrapMin) wrap = wrapMin;
	    T3.setText(""+wrap);
	    
	    offset1 = (windowSize-1) / 2;
	    ND = new double[offset1*2+1][offset1*2+1];
	    
	    /*********************************************************/
	    
	    Checkbox tmp=g.getSelectedCheckbox();
	    if(tmp == cb1){
		maskA = mask1;
	    }
	    else if(tmp == cb2){
		maskA = mask2;
	    }
	    else if (tmp == cb3){
		maskA = mask3;
	    }
	    else if (tmp == cb4){
		maskA = mask4;
	    } 
	    else if (tmp == cb5){
		maskA = mask5;
	    }
	    /********************************************************/
	}
	
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+val/10.0);
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+(val*2+1));
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+(val));
	    }
	    
	}  
    }
    
    // tB^p[^ݒ肷邽߂̃plԂ
    public FilterPanel getFilterPanel(){
	return new  FilterTTTTPanel();
    }
}
