/*
	***FpĂׂhstB^***
			 *03KM024@c@GY*
*/

package imageFiltering.filter;

import imageFiltering.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;


/**FpĂׂhstB^**/
public class SikisaFilter2 extends Filter {

    //FtB^̃TCY(ł邱)
    int windowSize = 3;
    int windowSizeMax = 15;
    int windowSizeMin = 3;

    //F̂l(F:0`195)
    //ۂ̐F0`195075ł邪,1000ŊĂ.
    int Sikisa = 5;
    int SikisaMax = 195;
    int SikisaMin = 0;

    //fBAtB^̃TCY(ł邱)
    int medianSize = 3;
    int medianSizeMax = 15;
    int medianSizeMin = 3;

    //摜i[z
    //f[^ûR,G,Bꂼpӂ
    int imageR1[][];
    int imageG1[][];
    int imageB1[][];

    int imageR2[][];
    int imageG2[][];
    int imageB2[][];

    //摜̕ƍ
    int imageWidth;
    int imageHeight;


    /**tB^̖̂Ԃ*/
    public String getName() {

	//ꂼ̃tB^̖Oŏ
	return "ShikisaFilter2";

    }


    /**쐬tB^*/
    public void filter(AnimatedImage AI) {

	/**쐬tB^̋Lqs*/

	//摜̕ƍǂݍ
	imageWidth = AI.getWidth();
	imageHeight = AI.getHeight();

	//摜i[z
	imageR1 = new int [imageWidth][imageHeight];
	imageG1 = new int [imageWidth][imageHeight];
	imageB1 = new int [imageWidth][imageHeight];

	imageR2 = new int [imageWidth][imageHeight];
	imageG2 = new int [imageWidth][imageHeight];
	imageB2 = new int [imageWidth][imageHeight];

	//摜z̏
	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {
		imageR1[i][j] = 0;
		imageG1[i][j] = 0;
		imageB1[i][j] = 0;

		//̏lƃGbW̐FςB
		imageR2[i][j] = 0;
		imageG2[i][j] = 0;
		imageB2[i][j] = 0;
	    }
	}

	//摜ǂݍ݊i[
	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {
		imageR1[i][j] = AI.getR(i,j);
		imageG1[i][j] = AI.getG(i,j);
		imageB1[i][j] = AI.getB(i,j);
	    }
	}

	//fBAtB^
	getMedian();

	//FtB^
	//㏑ĂtB^ɕύX
	getSikisa2();

	//ʂo
	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {
		    //㏑Ă̂ŔzςĂ
		    AI.setRGB(i,j,imageR1[i][j],imageG1[i][j],imageB1[i][j]);
	    }
	    this.switchThread();
	}
	this.switchThread();
	AI.repaintAll();
	return;
    }


    /**fBAtB^郁\bh*/
    public void getMedian() {

	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {
		int offset = (int)(medianSize/2);
		int index = 0;

		int dataR[] = new int[medianSize*medianSize];
		int dataG[] = new int[medianSize*medianSize];
		int dataB[] = new int[medianSize*medianSize];

		for (int l=-offset; l<=offset; l++) {
		    for (int k=-offset; k<=offset; k++) {
			//摜̒li[
			//if͉ʂ̒[̕ɑ΂鏈
			if (i+k<=0 || i+k>=imageWidth || j+l<=0 || j+l>=imageHeight) {
			    dataR[index] = imageR1[i][j];
			    dataG[index] = imageG1[i][j];
			    dataB[index] = imageB1[i][j];
			    index++;
			}
			else {
			    dataR[index] = imageR1[i+k][j+l];
			    dataG[index] = imageG1[i+k][j+l];
			    dataB[index] = imageB1[i+k][j+l];
			    index++;
			}
		    }
		}
	
		//l(fBA)
		int medianR = 0;
		int medianG = 0;
		int medianB = 0;

		for (int m=0; m<(medianSize*medianSize-1); m++) {
		    for (int n=m; n<(medianSize*medianSize-1); n++) {
			if (dataR[m]<dataR[n+1]) {
			    medianR = dataR[m];
			    dataR[m] = dataR[n+1];
			    dataR[n+1] = medianR;
			}
			if (dataG[m]<dataG[n+1]) {
			    medianG = dataG[m];
			    dataG[m] = dataG[n+1];
			    dataG[n+1] = medianG;
			}
			if (dataB[m]<dataB[n+1]) {
			    medianB = dataB[m];
			    dataB[m] = dataB[n+1];
			    dataB[n+1] = medianB;
			}
		    }
		}
		imageR1[i][j] = dataR[(medianSize*medianSize-1)/2];
		imageG1[i][j] = dataG[(medianSize*medianSize-1)/2];
		imageB1[i][j] = dataB[(medianSize*medianSize-1)/2];
	    }
	}
    }


    /**FtB^郁\bh*/
    //ʂVzɊi[郁\bh
    public void getSikisa1() {
	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {

		//_̐Fl߂
		int baseR = imageR1[i][j];
		int baseG = imageG1[i][j];
		int baseB = imageB1[i][j];

		int baseCr = getCr(baseR, baseG, baseB);
		int baseCb = getCb(baseR, baseG, baseB);
		int baseL = getLuminance(baseR, baseG, baseB);
		int baseSikichi = (baseL*baseL + baseCr*baseCr + baseCb*baseCb);
		int offset = (int)(windowSize/2);
		int hantei = 0;

		int R = 0;
		int G = 0;
		int B = 0;

		//r_̐Fl߂
		for (int l=-offset; l<=offset; l++) {
		    for (int k=-offset; k<=offset; k++) {
			if (i+k<0 || i+k>=imageWidth || j+l<0 || j+l>=imageHeight) {
			    //摜̒[̕
			    R = imageR1[i][j];
			    G = imageG1[i][j];
			    B = imageB1[i][j];
			}
			else {
			    R = imageR1[i+k][j+l];
			    G = imageG1[i+k][j+l];
			    B = imageB1[i+k][j+l];
			}
			int Luminance = getLuminance(R, G, B);
			int Cr = getCr(R, G, B);
			int Cb = getCb(R, G, B);
			int Sikichi = (Luminance*Luminance + Cr*Cr + Cb*Cb);				hantei += Math.abs(baseSikichi-Sikichi);
		    }
		}

		//F𔻒肷
		if (hantei<Sikisa*1000*windowSize*windowSize) {
		    for (int l=-offset; l<=offset; l++) {
			for (int k=-offset; k<=offset; k++) {
			    if (i+k<0 || i+k>=imageWidth || j+l<0 || j+l>=imageHeight) {
				//摜̒[̕
				break;
			    }
			    else {
				imageR2[i+k][j+l] = imageR1[i][j];
				imageG2[i+k][j+l] = imageG1[i][j];
				imageB2[i+k][j+l] = imageB1[i][j];
			    }
			}
		    }
		}
	    }
	}
    }


    /**FtB^郁\bh2*/
    //ʂ㏑ĔzɊi[郁\bh
    public void getSikisa2() {
	for (int j=0; j<imageHeight; j++) {
	    for (int i=0; i<imageWidth; i++) {
		int baseR = imageR1[i][j];
		int baseG = imageG1[i][j];
		int baseB = imageB1[i][j];

		int baseCr = getCr(baseR, baseG, baseB);
		int baseCb = getCb(baseR, baseG, baseB);
		int baseL = getLuminance(baseR, baseG, baseB);
		int baseSikichi = (baseL*baseL + baseCr*baseCr + baseCb*baseCb);
		int offset = (int)(windowSize/2);
		int hantei = 0;

		for (int l=-offset; l<=offset; l++) {
		    for (int k=-offset; k<=offset; k++) {
			if (i+k<0 || i+k>=imageWidth || j+l<0 || j+l>=imageHeight) {
			    //摜̒[̕
			    int R = imageR1[i][j];
			    int G = imageG1[i][j];
			    int B = imageB1[i][j];
			}
			else {
			    int R = imageR1[i+k][j+l];
			    int G = imageG1[i+k][j+l];
			    int B = imageB1[i+k][j+l];

			    int Luminance = getLuminance(R, G, B);
			    int Cr = getCr(R, G, B);
			    int Cb = getCb(R, G, B);
			    int Sikichi = (Luminance*Luminance + Cr*Cr + Cb*Cb);			    hantei += Math.abs(baseSikichi-Sikichi);
			    }
			}
		    }

		if (hantei<Sikisa*1000*windowSize*windowSize) {
		    for (int l=-offset; l<=offset; l++) {
			for (int k=-offset; k<=offset; k++) {
			    if (i+k<0 || i+k>=imageWidth || j+l<0 || j+l>=imageHeight) {
				//摜̒[̕
				break;
			    }
			    else {
				imageR1[i+k][j+l] = imageR1[i][j];
				imageG1[i+k][j+l] = imageG1[i][j];
				imageB1[i+k][j+l] = imageB1[i][j];
			    }
			}
		    }
		}
	    }
	}
    }


    /**Px߂郁\bh*/
    public int getLuminance(int r, int g, int b) {
	int ret = (int)(0.3f*(float)r + 0.59f*(float)g + 0.11f*(float)b);
	if (ret<0) ret = 0;
	if (ret>255) ret = 255;
	return ret;
    }


    /**FCr߂郁\bh*/
    public int getCr(int r, int g, int b) {
	int ret = (int)(0.5f*(float)r - 0.42f*(float)g - 0.08f*(float)b +128.0f);
	if (ret<0) ret = 0;
	if (ret>255) ret = 255;
	return ret;
    }


    /**FCb߂郁\bh*/
    public int getCb(int r, int g, int b) {
	int ret = (int)(-0.17f*(float)r - 0.33f*(float)g + 0.5f*(float)b +128.0f);
	if (ret<0) ret = 0;
	if (ret>255) ret = 255;
	return ret;
    }


    /* pl */
    class SikisaFilterPanel2 extends FilterPanel implements AdjustmentListener {

	Label L1 = new Label("SikisaFilter Parameter");
	Label L2 = new Label("window Size(3-25) ł邱");
	Label L3 = new Label("Sikisa(0-195)");
	Label L4 = new Label("");
	Label L5 = new Label("median Size(3-25) ł邱");

	TextField T1 = new TextField("" + windowSize,5);
	TextField T2 = new TextField("" + Sikisa,5);
	TextField T3 = new TextField("" + medianSize,5);

	Scrollbar S1 = new Scrollbar(Scrollbar.HORIZONTAL,(windowSize-1)/2,1,3,13);
	Scrollbar S2 = new Scrollbar(Scrollbar.HORIZONTAL,20,1,0,440);
	Scrollbar S3 = new Scrollbar(Scrollbar.HORIZONTAL,(medianSize-1)/2,1,3,13);

	SikisaFilterPanel2() {
	    this.setLayout(new GridLayout(20,1));
	    this.add(new Container());
	    this.add(this.L1);
	    this.add(this.L2);
	    this.add(this.S1);
	    this.add(this.T1);
	    this.add(this.L3);
	    this.add(this.S2);
	    this.add(this.T2);
	    this.add(this.L4);
	    this.add(this.L5);
	    this.add(this.S3);
	    this.add(this.T3);
	    S1.addAdjustmentListener(this);
	    S2.addAdjustmentListener(this);
	    S3.addAdjustmentListener(this);
	}

	public void setFilterParameter(){
		try {
			windowSize = Integer.parseInt(T1.getText());
		}
		catch(NumberFormatException e){}
		if(windowSize > windowSizeMax) windowSize = windowSizeMax;
		if(windowSize < windowSizeMin) windowSize = windowSizeMin;
		T1.setText(""+windowSize);
		try{
		    Sikisa = Integer.parseInt(T2.getText());
		}
		catch(NumberFormatException e){}
		if(Sikisa > SikisaMax) Sikisa = SikisaMax;
		if(Sikisa < SikisaMin) Sikisa = SikisaMin;
		T2.setText(""+Sikisa);
		try {
			medianSize = Integer.parseInt(T3.getText());
		}
		catch(NumberFormatException e){}
		if(medianSize > medianSizeMax) medianSize = medianSizeMax;
		if(medianSize < medianSizeMin) medianSize = medianSizeMin;
		T3.setText(""+medianSize);
	}

	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	    int val;
	    Scrollbar se = (Scrollbar) e.getSource();
	    if(se == S1){
		val = S1.getValue();
		T1.setText(""+(val*2+1));
	    }
	    else if(se == S2){
		val = S2.getValue();
		T2.setText(""+val);
	    }
	    else if(se == S3){
		val = S3.getValue();
		T3.setText(""+(val*2+1));
	    }
	}  
    }

    public FilterPanel getFilterPanel(){
	return new SikisaFilterPanel2();
    }

}